#!/usr/local/bin/perl

###########################################################################
#                         change_database.pl                              #
#                                                                         #
# This script was written by Selena Sol (selena@eff.org                   #
# http://www.eff.org/~erict) having been inspired by countless other      #
# perl authors.  Feel free to copy, cite, reference, sample, borrow or    #
# plagiarize the contents.  However, please let me know where it goes so  #
# that I can at least watch and take part in the development of the       #
# memes. Information wants to be free, support public domain freware.     #
#                                                                         #
###########################################################################

# Gather form data and set some server specific variables.

  require "./get_post_form_data.pl";
  require "./process_get_form_data.pl";
  require "./define_variables.pl";

# Print out the HTML header

  print "Content-type: text/html\n\n";

# If this script has been asked to add, do the following...

  if ($MYDATA{'add'} ne "")
    {

# Assign a counter number to the new entry to make it a unique entry for 
# modification and deletion

    $counter = `$tail_command -1 $counter_file`;
    $counter += 1;
    open (NOTE, ">$counter_file")  || die "can't open";
    print NOTE "$counter\n";
    close (NOTE);

# Open up the database file

    open (DATA, ">>$database_file")   || die "can't open";

# Print the information to the database file...but make the addition line 
# shorter so it doesn't get wrapped by making the variable names shorter 
# for a couple of variables.

    $name =  "$MYDATA{'name'}";
    $email = "$MYDATA{'email'}";
    $subject = "$MYDATA{'subject'}";
    $time = "$MYDATA{'time'}";
    $month = "$MYDATA{'month'}";
    $day = "$MYDATA{'day'}";
    $year = "$MYDATA{'year'}";
    $comments = "$MYDATA{'comments'}";

    print DATA "$day|$month|$year|$name|$email|$subject|$time|$comments|$counter\n";
    close (DATA);

# Print out the HTMl footer

    print "<HTML><HEAD><TITLE>$frontpage_title</TITLE></HEAD>\n";
    print "<BODY BACKGROUND=\"$background\">\n";
    print "<H2><CENTER>Your item has been added, thanks.</H2>";
    print "<FORM METHOD = \"POST\" ACTION=\"display_month.pl\">";
    print "<INPUT TYPE = \"hidden\" NAME = \"month\" VALUE = \"$MYDATA{'month'}\">";
    print "<INPUT TYPE = \"hidden\" NAME = \"day\" VALUE= \"$MYDATA{'day'}\">";
    print "<INPUT TYPE = \"hidden\" NAME = \"year\" VALUE = \"$MYDATA{'year'}\">";
    print "<INPUT TYPE=\"SUBMIT\" VALUE=\"View Month\">";
    print "</FORM></CENTER></BODY></HTML>";

# Now sort the events database by time so that when people view days, 
# they will have the events in chronological order.

    system ("$sort_command -n +6 -t\\| $database_file > $temp_file");
    system ("mv $temp_file $database_file");
    die;
    }


# In the case this script is called to delete an item, do the following

  if ($MYDATA{'delete'} ne "")
    {

# Open the database file

    open (DATA, "$database_file")   || die "can't open";

# Create a temporary file

    open (TEMP, ">$temp_file");
    close (TEMP);

# While data in the database file check to see which item matches the 
# deletion

    while (<DATA>)
      {
      @grepfields=split(/\|/,$_);
      $counter1 = $grepfields[8];

# If the item matches the deletion, it won't be repinted to the temp file 
# so that when we copy over the old databse with the temp file, the deleted 
# item will not appear.

      if ($counter1 ne "$MYDATA{'delete_data'}")
        {
        open (TEMP, ">>$temp_file")  || die "can't open";
        print TEMP "$_";
        close (TEMP);
        }
      }    
    system ("mv $temp_file $database_file");
    close (DATA);

# print out an HTML version of the table

    print "<HTML><HEAD><TITLE>$frontpage_title</TITLE></HEAD>\n";
    print "<BODY BACKGROUND=\"$background\">\n";
    print "<H2><CENTER>Your item has been deleted, thanks.</H2>";
    print "<FORM METHOD = \"POST\" ACTION=\"display_month.pl\">";
    print "<INPUT TYPE = \"hidden\" NAME = \"month\" VALUE = \"$MYDATA{'month'}\">";
    print "<INPUT TYPE = \"hidden\" NAME = \"day\" VALUE= \"$MYDATA{'day'}\">";
    print "<INPUT TYPE = \"hidden\" NAME = \"year\" VALUE = \"$MYDATA{'year'}\">";
    print "<INPUT TYPE=\"SUBMIT\" VALUE=\"View Month\">";
    print "</FORM></CENTER></BODY></HTML>";
    die;
    system ("$sort_command -n +6 -t\\| $database_file > $temp_file");
    system ("mv $temp_file $database_file");
    }

# Finally in the case of modify....

  if ($MYDATA{'modify'} ne "")
    {    
 
# Split out the information from the form

    ($day,$month,$year,$name,$email,$subject,$event_time,$body,$database_id_number) = split (/\|/, $MYDATA{'modify_data'});

# open up the database file and create a temp file

    open (DATA, "$database_file")  || die "can't open";
    open (TEMP, ">$temp_file")  || die "can't open";
    close (TEMP);

# If the counter variables don't match, the line won't be written to the 
# new file and won't be copied along with the rest when the temp file 
# copies over the old database file.

    while (<DATA>)
      {
      @grepfields=split(/\|/,$_);
      $counter1 = $grepfields[8];
      if ($database_id_number ne "$counter1")
        {
        open (TEMP, ">>$temp_file")  || die "can't open";
        print TEMP "$_";
        close (TEMP);
        }
      }    
    close (DATA);

# Now substitute new data

    if ($MYDATA{'day'} ne "")
        {
        $day = $MYDATA{'day'};
        }  
    if ($MYDATA{'month'} ne "")
        {
        $month = $MYDATA{'month'};
        }
    if ($MYDATA{'year'} ne "")
        {
        $year = $MYDATA{'year'};
        }
    if ($MYDATA{'name'} ne "")
        {
        $name = $MYDATA{'name'};
        }
    if ($MYDATA{'email'} ne "")
        {
        $email = $MYDATA{'email'};
        }
    if ($MYDATA{'subject'} ne "")
        {
        $subject = $MYDATA{'subject'};
        }
    if ($MYDATA{'time'} ne "")
        {
        $time = $MYDATA{'time'};
        }
    if ($MYDATA{'body'} ne "")
        {
        $body = $MYDATA{'body'};
        }
    if ($MYDATA{'database_id_number'} ne "")
        {
        $database_id_number = $MYDATA{'database_id_number'};
        }
    open (DATA, ">>$temp_file")  || die "can't open";
    print DATA "$day|$month|$year|$name|$email|$subject|$time|$body|$database_id_number";
    close (DATA);
    system ("mv $temp_file $database_file");

# print out HTML table...

  print "<HTML><HEAD><TITLE>$frontpage_title</TITLE></HEAD>\n";
  print "<BODY BACKGROUND=\"$background\">\n";
  print "<FORM METHOD=POST ACTION=\"db_gateway.pl\">";
  print "<CENTER><H2>$MYDATA{'month'} - $MYDATA{'day'} - $MYDATA{'year'}</H2></CENTER>";
  print "<TABLE BORDER= \"1\" CELLPADDING= \"1\" CELLSPACING = \"1\">";
  print "<TR>";
  print "<TH>Time</TH>";
  print "<TH>Subject</TH>";
  print "<TH>Name</TH>";
  print "<TH>Body</TH>";
  print "</TR><TR>";
  open (DAYFILE, "$database_file");
  while (<DAYFILE>)
    {
    @grepfields=split(/\|/,$_);
    $day = $grepfields[0];
    $month = $grepfields[1];
    $year = $grepfields[2];
    $name = $grepfields[3];
    $email = $grepfields[4];
    $subject = $grepfields[5];
    $time = $grepfields[6];
    $body = $grepfields[7];
    $database_id_number = $grepfields[8];
    if ($day eq "$MYDATA{'day'}" && $month eq "$MYDATA{'month'}" && $year eq "$MYDATA{'year'}")
      {
      print "<TD>$time</TD><TD>$subject</TD><TD><A HREF =\"mailto:$email\">$name</A></TD><TD>$body</TD></TR><TR>";
      }
    }
  print "</TR></TABLE><P>";
  print "<CENTER><INPUT TYPE=\"SUBMIT\" NAME = \"modify\" VALUE=\"Modify Item\">";
  print "<INPUT TYPE=\"SUBMIT\" NAME = \"delete\" VALUE=\"Delete Item\">";
  print "<INPUT TYPE = \"hidden\" NAME = \"month\" VALUE = \"$MYDATA{'month'}\">";
  print "<INPUT TYPE = \"hidden\" NAME = \"day\" VALUE = \"$MYDATA{'day'}\">";
  print "<INPUT TYPE = \"hidden\" NAME = \"year\" VALUE= \"$MYDATA{'year'}\">";
  print "<INPUT TYPE=\"SUBMIT\" NAME = \"add\" VALUE=\"Submit Addition\">";
  print "</FORM>";
  print "<FORM METHOD=POST ACTION=\"display_month.pl\">";
  print "<INPUT TYPE=\"SUBMIT\" VALUE=\"View Month\">";
  print "</FORM></CENTER></BODY></HTML>";
  system ("$sort_command -n +6 -t\\| $database_file > $temp_file");
  system ("mv $temp_file $database_file");
  }
