#!/usr/local/bin/perl

###########################################################################
#                         display_month.pl                                #
#                                                                         #
# This script was written by Selena Sol (selena@eff.org                   #
# http://www.eff.org/~erict) having been inspired by countless other      #
# perl authors.  Feel free to copy, cite, reference, sample, borrow or    #
# plagiarize the contents.  However, please let me know where it goes so  #
# that I can at least watch and take part in the development of the       #
# memes. Information wants to be free, support public domain freware.     #
# Also, this script could not have been done without the help of the      #
# amazing Gunther Birznieks <gunther@nchgr.nih.gov> who wrote the date    #
# array routines.                                                         #
#                                                                         #
###########################################################################

# Require the use of the date.pl cgi-library routines, gather form data, and 
# set some server specifc variables.

  require "./date.pl";
  require "./get_post_form_data.pl";
  require "./define_variables.pl";

# Print out the HTML header

  print "Content-type: text/html \n\n";
  print "<HTML><HEAD><TITLE>$frontpage_title</TITLE></HEAD>\n";
  print "<BODY BACKGROUND=\"$background\">\n";
  print "<FORM METHOD=POST ACTION=\"display_month.pl\">";
  print "<CENTER>";

# If this script is loading today's month, pass the current date given to 
# us by the &today subroutine in date.pl to the subroutine 
# &make_month_array in this script which will build the calendar array of 
# this month.

  if ($MYDATA{'year'} ne "")
    {
    $current_year = "$MYDATA{'year'}";
    }
  else
    {
    $current_year = "$the_current_year";
    }

  if ($MYDATA{'month'} eq "")
    {
    @mymonth = &make_month_array(&today);

# Clear out the value of $weekday

    $weekday = 0;

# Now print out the HTML calendar

    print "<CENTER><H2>$currentmonth - $currentyear</H2></CENTER>";
    print "<TABLE BORDER= \"2\" CELLPADDING= \"4\" CELLSPACING = \"4\">";
    print "<TR>";
    print "<TH>Sunday</TH>";
    print "<TH>Monday</TH>";
    print "<TH>Tuesday</TH>";
    print "<TH>Wednessday</TH>";
    print "<TH>Thursday</TH>";
    print "<TH>Friday</TH>";
    print "<TH>Saturday</TH>";
    print "</TR>";
    print "<TR>";

    foreach $x (@mymonth)
      {
      $weekday++;

# Make sure that we add a break for every week to make the calendar 2 
# dimensional.

      $weekday = 0 if ($weekday > 6);

# print the day's number

      print "<TD VALIGN=\"top\" WIDTH=\"150\"><A HREF=\"db_gateway.pl?day=$x&year=$currentyear&month=$currentmonth\">$x</A>";

# Grab the subject listings for all the entries on that day
        
      open (DATABASE, "$database_file");
      while (<DATABASE>)
        {
        @grepfields=split(/\|/,$_);
        $day = $grepfields[0];
        $month = $grepfields[1];
        $year = $grepfields[2];
        $name = $grepfields[3];
        $email = $grepfields[4];
        $subject = $grepfields[5];
        $body = $grepfields[6];
        $database_id_number = $grepfields[6];

          if ($day eq "$x" && $month eq "$currentmonth" && $year eq "$currentyear")
            {
            print "<BR><FONT SIZE=1>$subject</FONT>";  
            }
          } 

        print "</TD>";
	if ($weekday == 0)
	  {
	  print "</TR><TR>";
	  }
	else
	  {
	  print "";
	  }
	}

# print up the HTML footer

      print "</TABLE></CENTER>";
      print "<BLOCKQUOTE>";
      print "For day-at-a-glance-calendar, click on the day number on the ";
      print "calendar above.<BR>";
      print "Or, to see another 1996 month, choose one\n";

  print "<SELECT NAME=\"month\">";
  print "<OPTION VALUE = \"1\">January";
  print "<OPTION VALUE = \"2\">February";
  print "<OPTION VALUE = \"3\">March";
  print "<OPTION VALUE = \"4\">April";
  print "<OPTION VALUE = \"5\">May";
  print "<OPTION VALUE = \"6\">June";
  print "<OPTION VALUE = \"7\">July";
  print "<OPTION VALUE = \"8\">August";
  print "<OPTION VALUE = \"9\">September";
  print "<OPTION VALUE = \"10\">October";
  print "<OPTION VALUE = \"11\">November";
  print "<OPTION VALUE = \"12\">December";
  print "</SELECT><P>";
  print "Or, to see another year, enter the four digit numerical year value here (ie: 1994)\n";
  print "<INPUT TYPE =\"text\" NAME=\"year\" SIZE=\"4\"><P>";
  print "* Note: This calendar is best viewed by opening your ";
  print "browser window to its maximum size. And, you can only submit
  a month if the year field is cleared!<P>";
  print "</BLOCKQUOTE>";
  print "<CENTER><INPUT TYPE=\"SUBMIT\" VALUE=\"Change Month/Year\">";
  print "<INPUT TYPE=\"RESET\" VALUE=\"Clear this form\">";
  print "</FORM>";
    print "<FORM METHOD=POST ACTION=\"db_gateway.pl\">";
    print "<INPUT TYPE=\"SUBMIT\" NAME = \"add\" VALUE=\"Add Item\">";
    print "</FORM></CENTER></BODY></HTML>";

    }

# And if this script is being used to create the calendar for another 
# month besides this one...

  else 
    {
    @mymonth = &make_month_array(&jday($MYDATA{'month'},1,$current_year));

# Clear out the value of $weekday

    $weekday = 0;

# Now print out the HTML calendar

  print "<CENTER><H2>$MYDATA{'month'} - $current_year</H2></CENTER>";
  print "<TABLE BORDER= \"2\" CELLPADDING= \"4\" CELLSPACING = \"4\">";
  print "<TR>";
  print "<TH>Sunday</TH>";
  print "<TH>Monday</TH>";
  print "<TH>Tuesday</TH>";
  print "<TH>Wednessday</TH>";
  print "<TH>Thursday</TH>";
  print "<TH>Friday</TH>";
  print "<TH>Saturday</TH>";
  print "</TR>";
  print "<TR>";

# Basically the same as above with different data

    foreach $x (@mymonth)
      {
	$weekday++;
	$weekday = 0 if ($weekday > 6);
	print "<TD><A HREF=\"db_gateway.pl?day=$x&year=$current_year&month=$MYDATA{'month'}\">$x</A>";
        open (DATABASE, "$database_file");
        while (<DATABASE>)
          {
          @grepfields=split(/\|/,$_);
          $day = $grepfields[0];
          $month = $grepfields[1];
          $year = $grepfields[2];
          $name = $grepfields[3];
          $email = $grepfields[4];
          $subject = $grepfields[5];
          $body = $grepfields[6];
          $database_id_number = $grepfields[6];

          if ($day eq "$x" && $month eq "$currentmonth" && $year eq "$currentyear")
          {
          print "<BR><FONT SIZE=1>$subject</FONT>";  
          }
          } 
        print "</TD>";
	if ($weekday == 0)
		{
		print "</TR><TR>";
		}
	else
		{
		print "";
		}
	}
    print "</TABLE></CENTER>";
 print "<BLOCKQUOTE>";
  print "For day-at-a-glance-calendar, click on the day number on the ";
  print "calendar above.<BR>";
  print "Or, to see another 1996 month, choose one \n";
  print "<SELECT NAME=\"month\">";
  print "<OPTION VALUE = \"1\">January";
  print "<OPTION VALUE = \"2\">February";
  print "<OPTION VALUE = \"3\">March";
  print "<OPTION VALUE = \"4\">April";
  print "<OPTION VALUE = \"5\">May";
  print "<OPTION VALUE = \"6\">June";
  print "<OPTION VALUE = \"7\">July";
  print "<OPTION VALUE = \"8\">August";
  print "<OPTION VALUE = \"9\">September";
  print "<OPTION VALUE = \"10\">October";
  print "<OPTION VALUE = \"11\">November";
  print "<OPTION VALUE = \"12\">December";
  print "</SELECT><P>";
  print "Or, to see another year, enter the four digit numerical year value here (ie: 1994)\n";
  print "<INPUT TYPE =\"text\" NAME=\"year\" SIZE=\"4\"><P>";
  print "* Note: This calendar is best viewed by opening your ";
  print "browser window to its maximum size. And, you can only submit
  a month if the year field is cleared!<P>";
  print "</BLOCKQUOTE>";
  print "<CENTER><INPUT TYPE=\"SUBMIT\" VALUE=\"Change Month/Year\">";
  print "<INPUT TYPE=\"RESET\" VALUE=\"Clear this form\">";
    print "</FORM>";
    print "<FORM METHOD=POST ACTION=\"db_gateway.pl\">";
    print "<INPUT TYPE=\"SUBMIT\" NAME = \"add\" VALUE=\"Add Item\">";
    print "</FORM></CENTER></BODY></HTML>";
    }
##########################################################################
#                                SUBROUTINES                             #
##########################################################################

sub make_month_array
  {

# Define some variables which will be local to this subroutine

  local($juldate)  = $_[0];
  local($month,$day,$year,$weekday);
  local($tempjdate,$firstweekday,$numdays,$lastweekday);
  local(@myarray);

# The following line gets the date of the passed parameter

  ($month, $day, $year, $weekday) = jdate($juldate);

# Make a NEW date based on the FIRST of the month instead

  $tempjdate = jday($month, 1, $year);

# get weekday of 1st of the month

  ($month, $day, $year, $weekday) = jdate($tempjdate);
  $firstweekday = $weekday;
 
  $currentmonth = "$month";
  $currentyear = "$year";

  $month++; 
  if ($month > 12)
    {
    $month = 1;
    $year++;
    }

  $tempjdate = jday($month,1,$year);
  $tempjdate--;
  ($month, $day, $year, $weekday) = jdate($tempjdate);
  $numdays = $day;
  $lastweekday = $weekday;

  for ($x = 0;$x < $firstweekday; $x++)
    {
    $myarray[$x] = " ";
    } #End of for

  for ($x = 1; $x <= $numdays; $x++ )
    {
    $myarray[$x + $firstweekday - 1] = $x;
    }

  for ($x = $lastweekday; $x < 6; $x++)
    {
    push(@myarray,"");
    }
  
  return @myarray;
  }


