#!/usr/local/bin/perl

###########################################################################
#                        address_update.cgi                               #
#                                                                         #
# This script was written by Selena Sol (selena@eff.org                   #
# http://www.eff.org/~erict) having been inspired by countless other      #
# perl authors.  Feel free to copy, cite, reference, sample, borrow or    #
# plagiarize the contents.  However, please let me know where it goes so  #
# that I can at least watch and take part in the development of the       #
# memes. Information wants to be free, support public domain freware.     #
#                                                                         #
###########################################################################


# Set a server-specific variables.  You'll need to change this path for
# your own setup.  Also, remember to setchmod and chown stuff for your setup.

    $datafile = "/home/selena/public_html/cgi-bin/Data/address.data";
    $tempfile = "/home/selena/public_html/cgi-bin/Data/data.temp";
    $bakfile = "/home/selena/public_html/cgi-bin/Data/address.backup";
    $htmloutput = "/home/selena/public_html/cgi-bin/Data/address.html";

# Gather the "post" data sent from the HTML form
# This form parsing routine was adapted from a script by Robert John
# Mudry which was published by the Coriolis Group as freeware in "Serving
# The Web".  This is an excellent book which I recommend to any cgi
# programmer.

  $LENGTH = $ENV{'CONTENT_LENGTH'};
  while ($LENGTH--) 
    {
    $C = getc(STDIN);
    if ($C eq "=" || $C eq "&") 
      {
      $START = "0";
      } 
    else 
      {
      $START++;
      }
    if ($START <= "8192") 
      {
      $FORM_DATA .=$C;
      }
    }

# Split up the form data into variable name and variable value pairs

  foreach (split(/&/, $FORM_DATA)) 
    {
    ($NAME, $VALUE) = split(/=/, $_);
    $NAME =~ s/\+/ /g;
    $NAME =~ s/%([0-9|A-F]{2})/pack(C,hex($1))/eg;
    $VALUE =~ s/\+/ /g;
    $VALUE =~ s/%([0-9|A-F]{2})/pack(C,hex($1))/eg;
    $NUM = "0";
    while ($MYDATA{$NAME} ne "") 
      {
      $NUM++;
      $NAME =~ s/\.([0-9]+$)|$/\.$NUM/;
      }
    $MYDATA{$NAME} = $VALUE;
    }
   
# Take the data, add it to the growing database, and re-sort the database.

  open (NOTE, ">>$datafile");
  print NOTE "$MYDATA{'lname'}:$MYDATA{'fname'}:$MYDATA{'email'}\n";
  close (NOTE);
  system ("sort -f $datafile > $tempfile");
  system ("mv $datafile $bakfile");
  system ("mv $tempfile $datafile");
  system ("rm $tempfile");
  chmod (0664, "$datafile");

# Create the new update HTML page from the new, sorted database file.  
# First create the standard header

  $index=0;
  open (DATA, "$datafile");
  open (OUTPUT, ">$htmloutput");
  print OUTPUT "<HTML><HEAD>\n";
  print OUTPUT "<TITLE>Database Update Response</TITLE>\n";
  print OUTPUT "</HEAD><BODY>\n";
  print OUTPUT "<table border>\n";
  print OUTPUT "<TR>\n";
  print OUTPUT "<th>Last Name</th>\n";
  print OUTPUT "<th>First Name</th>\n";
  print OUTPUT "<th>E-Mail</th>\n";
  print OUTPUT "</TR>\n";

# Now start adding each line of data from the datafile.  First split up 
# the data into variables

  file:
  while (<DATA>)
    {
    chop;
    ($lname,$fname,$email,$phone,)
    = split (/\:/, $_,3);

# Now print out the data in its HTML format

    print OUTPUT "<TR>\n";
    print OUTPUT "<TD>$lname</TD>\n";
    print OUTPUT "<TD>$fname</TD>\n";
    print OUTPUT "<TD>$email</TD>\n";
    print OUTPUT "<TD>$phone</TD>\n";
    print OUTPUT "</TR>\n";
    next file;
    }
  print OUTPUT "</TABLE>\n";
  close (DATA);
  close (OUTPUT);
  chmod (0664, "$datafile");

# Now send back an HTML document letting the updater know that the 
# update was successfull

  print "Content-type: text/html\n\n";
  print "<HTML><HEAD></HEAD><BODY><H1>The update was successful!</H1>\n";
  print "Check out the new updated HTML database at 
  <A HREF=\"http://www.nchgr.nih.gov/~selena/cgi-bin/Data/address.html\">http://www.nchgr.nih.gov/~selena/cgi-bin/Data/address.html</A>";
  print "<BR>Don't forget to hit \"reload\" whenever you return to the page 
  to see new changes";
  print "</BODY></HTML>";
