#!/usr/local/bin/perl

###########################################################################
#                       generate_post.cgi                                 #
#                                                                         #
# This script was written by Selena Sol (selena@eff.org                   #
# http://www.eff.org/~erict) having been inspired by countless other      #
# perl authors.  Feel free to copy, cite, reference, sample, borrow or    #
# plagiarize the contents.  However, please let me know where it goes so  #
# that I can at least watch and take part in the development of the       #
# memes. Information wants to be free, support public domain freware.     #
#                                                                         #
###########################################################################

# Gather and sort the incoming data with the subroutine get_form_data
# which can be found at the end of this script in the subroutines section.

  require "./get_form_data.pl";

# Define some server specific variables be accessing the variable
# defining file define_variables.cgi which should be in the same directory
# as this script.

  require "./define_variables.cgi";

# Make sure that the person coming in is coming through the frontpage.
# The point of this is mainly to make sure that the person carries with
# him/her the mid, oldmid and hostory variables...if the person tries to
# access the BBS in the middle, their messages will be lost.  Also, you
# may have a password login on the homepage so that only paying customers
# could get into the BBS area...you wouldn't want people to be able to
# jump into the system if they happened to acquire the right URL.

  if ($MYDATA{'oldmid'} eq "")
    {
    print "Content-type: text/html\n\n";
    print "<HTML><HEAD><TITLE>$gen_first_page_title</TITLE></HEAD>";
    print "<BODY BACKGROUND=\"$background\">";
    print "Sorry, you have to start at the  ";
    print "<A HREF=\"$frontpage_url\">beginning</A>!";
    print "</BODY></HTML>";
    die
    }

# Find out who wrote this message.  Also, substitue all ~~'s for :  The 
# reason  we do this is because since : is used to delimt fields, when 
# people enter : in their message, we need to store it as something  
# else.  Hopefully, noone will use two ~'s in a row...if they do, it will 
# be outputted as a :  but better this than to lose :'s

  open(HEADER,$header);
  while (<HEADER>)
    {
    @grepfields=split(/:/,$_);
    $lname = $grepfields[0];
    $fname = $grepfields[1];
    $email = $grepfields[2];
    $date = $grepfields[3];
    $subject = $grepfields[4];
    $history = $grepfields[5];
    $lname =~ s/~~/:/g;
    $fname =~ s/~~/:/g;
    $email =~ s/~~/:/g;
    $date =~ s/~~/:/g;
    $subject =~ s/~~/:/g;
    $history =~ s/~~/:/g;
    }
  close (HEADER);

# Gather the body of the message inputing a <P> for paragraph breaks and 
# substitue all ~'s for :  The reason we do this is because since : is used 
# to delimt fields, when people enter : in their message, we need to store 
# it as something else.  Hopefully, noone will use two ~'s in a row...if 
# they do, it will be outputted as a :  but better this than to lose :'s

  $_ = `cat $body`;
  $data = $_;
  $data =~ s/\.\s/\./g;
  $data =~ s/\s\s/<P>/g;
  $data =~ s/~~/:/g;

# Output the HTML version of the post!

  print "Content-type: text/html\n\n";
  print "<HTML><HEAD><TITLE>$page_name</TITLE></HEAD>";
  print "<BODY BACKGROUND=\"$background\">";
  print "<FONT SIZE=+1>";
  print "<B>Name:</B> $fname $lname<BR>";
  print "<B>Email:</B> <A HREF=\"mailto:$email\">$email</A><BR>";
  print "<B>Date:</B> $date<BR>";
  print "<B>Subject:</B> $subject<BR>";
  print "</FONT>";
  print "<B>Body:</B><BLOCKQUOTE>$data</BLOCKQUOTE>";
  print "<B>Replies:</B><BLOCKQUOTE>";

# Gather the replies from the reply list file.   However, we also want 
# to get the last modified information for the reply
# file...so we must first obtain the name of the file
# ($reply_file_path/replies_$url.list), then check the last modification
# time with ls -ltr, put the output of the ls into a format we can handle
# (colon delimited variable), assign the values to variables, and then
# use the values to display last modified date as well as the file subject.

  open (REPLIES, $reply_list);
  while (<REPLIES>)
    {
    ($url,$subject1) = split(/:/, $_);
    $lastmodifiedfile = "$reply_file_path/replies_$url.list";
    $lastmodified = `$ls $lastmodifiedfile`;
    $lastmodified =~ s/ /:/g;
    $lastmodified =~ s/::/:/g;    
    $lastmodified =~ s/::/:/g;    
    $lastmodified =~ s/::/:/g;    
    ($permissions,$num,$usr,$grp,$size,$month,$day,$hour,$minute,$filename) = split (/:/, $lastmodified);
    print "<A HREF=\"$generate_post_url&mid=$url\">Subject$subject1</A> ";
    print "(Modified $month $day at $hour:$minute)<BR>";
    }
  close (REPLIES);    

# Continue outputing the footer to HTML

  print "</BLOCKQUOTE>";
  print "<CENTER><P><IMG SRC=\"$line\"><P>";
  print "<A HREF=\"$post_response_script\">";
  print "<IMG SRC=\"$post_a_reply_button\" BORDER=0 ALT=\"[Post";
  print "a Message]\"></a>\n";
  print "<A HREF=\"$gen_first_page_script\">";
  print "<IMG SRC=\"$read_button\" BORDER=0 ALT=\"[Read";
  print "through Message Archive]\"></A>\n";
  print "</CENTER></BODY></HTML>";

