#!/usr/local/bin/perl

###########################################################################
#                       get_album_info.pl                                 #
#                                                                         #
# This script was written by Selena Sol (selena@eff.org                   #
# http://www.eff.org/~erict) having been inspired by countless other      #
# perl authors.  Feel free to copy, cite, reference, sample, borrow or    #
# plagiarize the contents.  However, please let me know where it goes so  #
# that I can at least watch and take part in the development of the       #
# memes. Information wants to be free, support public domain freware.     #
#                                                                         #
###########################################################################

# Set server specific variables.  You will need to change these lines to 
# reflect the paths of your own server.

  require "define_variables.pl";  

# First get the data from the form and parse it into variables. &get_form_data
# is a subroutine at the end of this script which does this job.

  &get_form_data;

# Print out some header information for the script-generated HTML page


  print "Content-type: text/html \n\n";
  print "<HTML><HEAD><TITLE>$album_info_title</TITLE></HEAD>";
  print "<BODY BACKGROUND=\"$background\">";
  print "<CENTER><H2>$album_info_title</H2></CENTER>";

# Gather the basic information by searching the datafile for the 
# requested catalog number then print out the resulting information to 
# the script-generated HTML response.

    $grepdata = `grep $MYDATA{'catalog_number'} $datafile`;
    $grepdata =~ s/$datafile://g;
    @grepfields=split(/:/,$grepdata);

    print "<B>Basic Info</B><BLOCKQUOTE>";
    print "Catalog Number: $grepfields[0]<BR>";
    print "Title:  $grepfields[1]<BR>";
    print "Artist: $grepfields[2]<BR>";
    print "Label: $grepfields[3]<BR>";
    print "Year Released: $grepfields[4]</BLOCKQUOTE>";

# Now get the album track information from the album track database
  
  print "<B>Album Tracks</B><BLOCKQUOTE>";

  $grepdata_song = `grep $MYDATA{'catalog_number'} $songfile`;
  $grepdata_song =~ s/$songfile://g;
  @grepfields = split(/:/,$grepdata_song);

# Give the album track a number (assuming that there are fewer than 100 
# tracks on the album)

  $x=1;
  while ($x < 99)
    {
    unless ($grepfields[$x] eq "")
      {
      print "Track $x: $grepfields[$x]<BR>";
      }
    $x++;
    }

# Print out the Album Review Information

  print "</BLOCKQUOTE><B>Album Review</B><BLOCKQUOTE>";

  $grepdata_review = `grep $MYDATA{'catalog_number'} $reviewfile`;
  $grepdata_review =~ s/$reviewfile://g;
  $grepdata_review =~ s/$MYDATA{'catalog_number'}://g;

  print "$grepdata_review</BLOCKQUOTE><P><CENTER>";

# Now print up the page footer

  print "<TABLE BORDER=\"0\" CELLPADDING=\"8\" CELLSPACING=\"8\">";
  print "<TR ALIGN=CENTER>";
  print "<TD><P><A HREF=\"$frontpage\">";
  print "<IMG SRC=\"$music_search_gif\" BORDER=\"0\"></A>";
  print "</TD ALIGN=\"center\"><P><TD>The Cool";
  print "<A HREF=\"$homepage\">";
  print "<IMG SRC=\"$homepage_gif\" BORDER=\"0\"></A>";
  print " Runnings<BR>Homepage</TD></TR></TABLE>";
  print "</CENTER></BODY></HTML>";

##########################################################################
#                                SUBROUTINES                             #
##########################################################################

sub get_form_data
  {
# This form parsing routine was adapted from a script by Robert John
# Mudry which was published by the Coriolis Group as freeware in "Serving
# The Web".  This is an excellent book which I recommend to any cgi
# programmer.

# First, split up $FORM_DATA into $NAME and $VALUE.  Store $VALUE
# in $MYDATA{$NAME} provided that $NAME is not already in use.  If it is, a
# temporary number stored in $NUM is incremented and a new the $VALUE is
# saved as the new variable.

  $FORM_DATA = $ENV{'QUERY_STRING'};
  foreach (split(/&/, $FORM_DATA))
    {
    ($NAME, $VALUE) = split(/=/, $_);
    $NAME =~ s/\+/ /g;
    $NAME =~ s/%([0-9|A-F]{2})/pack(C,hex($1))/eg;
    $VALUE =~ s/\+/ /g;
    $VALUE =~ s/%([0-9|A-F]{2})/pack(C,hex($1))/eg;

# Find unique Variable Name for every variable coming in from the form input

    $NUM = "0";
    while ($MYDATA{$NAME} ne "")
      {
      $NUM++;
      $NAME =~ s/\.([0-9]+$)|$/\.$NUM/;
      }
# Store Variable NAME=Variable VAUE pair

      $MYDATA{$NAME} = $VALUE;
   }
  }

