#!/usr/local/bin/perl

###########################################################################
#                               search.pl                                 #
#                                                                         #
# This script was written by Selena Sol (selena@eff.org                   #
# http://www.eff.org/~erict) having been inspired by countless other      #
# perl authors.  Feel free to copy, cite, reference, sample, borrow or    #
# plagiarize the contents.  However, please let me know where it goes so  #
# that I can at least watch and take part in the development of the       #
# memes. Information wants to be free, support public domain freware.     #
#                                                                         #
###########################################################################

# Set server specific variables

  require "define_variables.pl";

# First get the data from the form and parse it into variables. &get_form_data
# is a subroutine at the end of this script which does this job.

  &get_form_data;

# Figure out which keywords we are searching for and set permanent 
# variable names.

  if ($MYDATA{'name'} eq "")
    {
    $name = "none submitted";
    }
  else
    {
    $name = "$MYDATA{'name'}";
    }

  if ($MYDATA{'album'} eq "")
    {
    $album = "none submitted";
    }
  else
    {
    $album = "$MYDATA{'album'}";
    }

  if ($MYDATA{'song'} eq "")
    {
    $song = "none submitted";
    }
  else
    {
    $song = "$MYDATA{'song'}";
    }

# Send the first part of the HTML response

  print "Content-type: text/html \n\n";
  print "<HTML><HEAD><TITLE>$search_title</TITLE></HEAD>\n";
  print "<BODY BACKGROUND=\"$background\">\n";
  print "<CENTER><H2>Search Engine Search Results</H2></CENTER>";
  print "The following search is based on the following keywords";
  print "<BLOCKQUOTE>";
  print "<B>Artist</B>: $name<BR>";
  print "<B>Album</B>: $album<BR>";
  print "<B>Song</B>: $song<BR>";
  print "</BLOCKQUOTE>";
  print "<P><CENTER>";
  print "<TABLE BORDER=\"1\" CELLSPACING = \"3\" CELLPADDING = \"3\">";
  print "<TR ALIGN CENTER>";  
  print "<TH ALIGN=CENTER>Catalog Number</TH>";
  print "<TH ALIGN=CENTER>Title</TH>";
  print "<TH ALIGN=CENTER>Artist</TH>";
  print "<TH ALIGN=CENTER>Label</TH>";
  print "<TH ALIGN=CENTER>Year Recorded</TH>";
  print "</TR>";

#####################################

# First search by artist's name and save hits to a temporary file.

  unless ($name eq "none submitted")
    {
    $grepdata_name = `grep $name $datafile`;
    $grepdata_name =~ s/$datafile://g;
    open(TEMPFILE, ">$tempfile");
    print TEMPFILE "$grepdata_name";
    close (TEMPFILE);

# Now filter that list with the title keyword

  unless ($album eq "none submitted")
    {
    $grepdata_album = `grep $album $tempfile`;
    $grepdata_album =~ s/$tempfile://g;
    open(TEMPFILE, ">$tempfile");
    print TEMPFILE "$grepdata_album";
    close (TEMPFILE);
    }

# Now filter that list with the song keyword

  unless ($song eq "none submitted")
    {
    $grepdata_song = `grep $song $songfile`;
    $grepdata_song =~ s/$songfile://g;
    @grepfields = split(/:/,$grepdata_song);
    $grepdata_song = `grep $grepfields[0] $tempfile`;
    open(TEMPFILE, ">$tempfile");
    print TEMPFILE "$grepdata_song";
    close (TEMPFILE);
    }
  }  

#######################################

# Next search by album name in case the client did not fill out an artist 
# name and save hits to a temporary file.

  unless ($album eq "none submitted")
    {
    $grepdata_album = `grep $album $datafile`;
    $grepdata_album =~ s/$datafile://g;
    open(TEMPFILE, ">$tempfile");
    print TEMPFILE "$grepdata_album";
    close (TEMPFILE);

# Now filter that list with the title keyword

  unless ($name eq "none submitted")
    {
    $grepdata_name = `grep $name $tempfile`;
    $grepdata_name =~ s/$tempfile://g;
    open(TEMPFILE, ">$tempfile");
    print TEMPFILE "$grepdata_name";
    close (TEMPFILE);
    }

# Now filter that list with the song keyword

  unless ($song eq "none submitted")
    {
    $grepdata_song = `grep $song $songfile`;
    $grepdata_song =~ s/$songfile://g;
    @grepfields = split(/:/,$grepdata_song);
    $grepdata_song = `grep $grepfields[0] $tempfile`;
    open(TEMPFILE, ">$tempfile");
    print TEMPFILE "$grepdata_song";
    close (TEMPFILE);
    }
  }
########################################
# Finally search by song name in case the client did not fill out an artist
# or an album name and save hits to a temporary file.

  unless ($song eq "none submitted")
    {
    $grepdata_song = `grep $song $songfile`;
    $grepdata_song =~ s/$songfile://g;
    @grepfields = split(/:/,$grepdata_song);
    $grepdata_song = `grep $grepfields[0] $datafile`;
    open(TEMPFILE, ">$tempfile");
    print TEMPFILE "$grepdata_song";
    close (TEMPFILE);

# Now filter that list with the artist keyword

  unless ($name eq "none submitted")
    {
    $grepdata_name = `grep $name $tempfile`;
    $grepdata_name =~ s/$tempfile://g;
    open(TEMPFILE, ">$tempfile");
    print TEMPFILE "$grepdata_name";
    close (TEMPFILE);
    }

# Now filter that list with the album keyword
  unless ($album eq "none submitted")
    {
    $grepdata_album = `grep $album $datafile`;
    $grepdata_album =~ s/$tempfile://g;
    open(TEMPFILE, ">$tempfile");
    print TEMPFILE "$grepdata_album";
    close (TEMPFILE);
    }
  }

#########################################

# Now go through each hit

  open(DATA,$tempfile);
  while (<DATA>)
    {
    @grepfields=split(/:/,$_);
    $catalog_number = $grepfields[0];
    $title = $grepfields[1];
    $artist = $grepfields[2];
    $label = $grepfields[3];
    $year_released = $grepfields[4];
    print "<TR ALIGN=CENTER>";
    print "<TD ALIGN=CENTER><A HREF=\"$purchase_album_script=$catalog_number\">$catalog_number</A></TD>";
    print "<TD ALIGN=CENTER><A HREF=\"$get_album_info_script=$catalog_number\">$title</A></TD>";
    print "<TD ALIGN=CENTER>$artist</TD>";
    print "<TD ALIGN=CENTER>$label</TD>";
    print "<TD ALIGN=CENTER>$year_released</TD>";
    print "</TR>";
    }
  close(DATA);

# Finally send the HTML footer

  print "</TABLE></CENTER><P>";
  print "<I>NOTE</I>: If you would like to order a copy of an album, 
        click on the Catalog Number next to it.  If you would like to see 
        album tracks and album review, click on the album name. (Shopping cart not yet 
        functional)";
  print "<CENTER><TABLE BORDER=\"0\" CELLPADDING=\"8\" CELLSPACING=\"8\"><TR ALIGN=CENTER>";
  print "<TD><P><A HREF=\"frontpage.pl\">";
  print "<IMG SRC=\"http://www.nchgr.nih.gov/Images/Selena/music_search.gif\" BORDER=\"0\"></A>";
  print "</TD ALIGN=\"center\"><P><TD>The Cool <A HREF=\"http://homepage.interaccess.com/~coolcrew/main1.html\">";
  print "<IMG SRC=\"http://www.nchgr.nih.gov/Images/Selena/home.gif\" BORDER=\"0\"></A>";
  print " Runnings<BR>Homepage</TD></TR></TABLE></CENTER>";
  print "</BODY></HTML>";

##########################################################################
#                                SUBROUTINES                             #
##########################################################################

sub get_form_data
  {

# This form parsing routine was adapted from a script by Robert John
# Mudry which was published by the Coriolis Group as freeware in "Serving
# The Web".  This is an excellent book which I recommend to any cgi
# programmer.

# First, make sure that the comments section does not include too many
# charcters...

  $LENGTH = $ENV{'CONTENT_LENGTH'};
  if ($LENGTH > "32768")
    {
    die "major network spam, stopped";
    }

# Now, dump the information from the browser into variable $C for
# filtration.  Because of the http protocols, if the charcter coming in
# is an "=", we know a value is starting .  If the character is an "&",
# we know that its the end of a value.  Use the $START variable to watch
# the size of the input.  So long as it is small enough, things are
# fine and $FORM_DATA should be appended.  If not, disregard the long
# string.  The reason that the limit above was 32768, when here it is
# 8192 is because we don't want a legitimate blabbermouth to get cut off.

  while ($LENGTH--)
    {
    $C = getc(STDIN);
    if ($C eq "=" || $C eq "&")
      {
      $START = "0";
      }
    else
      {
      $START++;
      }
    if ($START <= "8192")
      {
      $FORM_DATA .=$C;
      }
    }

# Now, split up $FORM_DATA into $NAME and $VALUE.  Store $VALUE
# in $MYDATA{$NAME} provided that $NAME is not already in use.  If it is, a
# temporary number stored in $NUM is incremented and a new the $VALUE is
# saved as the new variable.

  foreach (split(/&/, $FORM_DATA))
    {
    ($NAME, $VALUE) = split(/=/, $_);
    $NAME =~ s/\+/ /g;
    $NAME =~ s/%([0-9|A-F]{2})/pack(C,hex($1))/eg;
    $VALUE =~ s/\+/ /g;
    $VALUE =~ s/%([0-9|A-F]{2})/pack(C,hex($1))/eg;

# Find unique Name

    $NUM = "0";
    while ($MYDATA{$NAME} ne "")
      {
      $NUM++;
      $NAME =~ s/\.([0-9]+$)|$/\.$NUM/;
      }

# Store NAME=VAUE pair

    $MYDATA{$NAME} = $VALUE;
    }
  }
