#!/usr/local/bin/perl

###########################################################################
#                      browse_warehouse.cgi                               #
#                                                                         #
# This script was written by Selena Sol (selena@eff.org                   #
# http://www.eff.org/~erict) having been inspired by countless other      #
# perl authors.  Feel free to copy, cite, reference, sample, borrow or    #
# plagiarize the contents.  However, please let me know where it goes so  #
# that I can at least watch and take part in the development of the       #
# memes. Information wants to be free, support public domain freware.     #
#                                                                         #
###########################################################################

# Define server specific variables

  require "./define_variables.pl";

# Gather the data from the form

  require "$get_get_form_data_script";

# Begin the HTML response

  print "Content-type: text/html \n\n";
  print "</CENTER>";

# Now determine if this is a new client, or a client who already has a
# userid #.  If it is not a new client (the last form sent the userid
# with the rest of the form data) assign the userid value to a variable
# $userid

  if ($MYDATA{'userid'} ne "")
    {
    $userid = "$MYDATA{'userid'}";
    }

# If it is a "new" client, assign the client a userid #.  Basically, this
# routine uses a counter file which is incremented by one each time a new
# user enters the store...this assures that each new client will have her
# own unique id number.  The routine checks to see what the counter list is
# up to, adds one to that number, assigns the new value to the client's id
# and then changes the counter list to be the new incremented number.

  if ($MYDATA{'userid'} eq "")
    {
    $userid = `tail -1 $counter`;
    $userid += 1;
    open (NOTE, ">>$counter");
    print NOTE "$userid\n";
    close (NOTE);

# Since this is a new client, create a unique shopping cart for them to use.

    open (NEWCART, ">$client_directory/$userid.cart");
    close (NEWCART);
    chmod(0777, "$client_directory/$userid.cart");
    }

# Okay, now we need to figure out what it is that the client has accessed
# this script for. If the client is asking to go back to the frontpage,
# output a dynamic version of that frontpage including the client's
# userid #.  This is crucial because we do not want them to lose their
# cart information.  output_frontpage is a subroutine at the end of this
# script which will output the index.html file with userid information
# tacked on.

  if ($MYDATA{'page'} eq "index.html")
    {
    &output_frontpage;
    }

# Otherwise, find out what page the client is interested in seeing and 
# output the page to her with a couple of dynamically added/genrated 
# variables.  First open the HTML doc and then print out the contents.

  open (PAGE, "$docs_directory/$MYDATA{'page'}");

  $searchstring = "userid";
  $replacestring = "userid=$userid";
  system ("sed s/$searchstring/$replacestring/g $docs_directory/$MYDATA{'page'} > $tempfile1");
  open (OUTPUT, "$tempfile1");
  while (<OUTPUT>)
    {
    print "$_";
    }
  system ("rm $tempfile1");
  print "<INPUT TYPE = \"hidden\" NAME = \"userid\" VALUE = \"$userid\">";
  print "<INPUT TYPE = \"hidden\" NAME = \"referring_page\" VALUE = \"$MYDATA{'page'}\">";

# Now print up the footer of the HTML page including the dynamically 
# generated variables.

  print "</FORM></BODY></HTML>";
  die;

##############################################################################
#                                 Subroutines                                #
##############################################################################

sub output_frontpage
  {

# Look for the keyword userid and replace every occurance with 
# userid=$userid so that the reference will now contain that vitral peice 
# of info.

  $searchstring = "userid";
  $replacestring = "userid=$MYDATA{'userid'}";
  system ("sed s/$searchstring/$replacestring/g $frontpage > $tempfile1");

# Print out the page with the new URLs

  if ($MYDATA{'userid'} ne "")
{
print "
<CENTER>
<FORM METHOD=\"POST\"
ACTION=\"http://www.intbc.com/~ibc/cgi-bin/Smoke/build_shopping_cart.cgi\">
<INPUT TYPE = \"submit\" NAME = \"submit_type\" VALUE = \"View/Modify Cart\">
<INPUT TYPE = \"submit\" NAME = \"submit_type\" VALUE = \"Checkout Stand\">
<INPUT TYPE = \"submit\" NAME = \"submit_type\" VALUE = \"I Need Help\">";
  print "<INPUT TYPE = \"hidden\" NAME = \"referring_page\" VALUE = \"$MYDATA{'referring_page'}\">";
  print "<INPUT TYPE = \"hidden\" NAME = \"userid\" VALUE = \"$MYDATA{'userid'}\">";
  print "</CENTER></FORM>";
}

  open (OUTPUT, "$tempfile1");
  while (<OUTPUT>)
    {
    print "$_";
    }

# Clean up the system by removing the temporary edited file.

  system ("rm $tempfile1");
  die;
  }

