#!/usr/local/bin/perl

###########################################################################
#                  build_shopping_cart.pl                                 #
#                                                                         #
# This script was written by Selena Sol (selena@eff.org                   #
# http://www.eff.org/~erict) having been inspired by countless other      #
# perl authors.  Feel free to copy, cite, reference, sample, borrow or    #
# plagiarize the contents.  However, please let me know where it goes so  #
# that I can at least watch and take part in the development of the       #
# memes. Information wants to be free, support public domain freware.     #
#                                                                         #
###########################################################################

# Define server specific variables

  require "./define_variables.pl";

# Gather the data from the form

  require "$get_form_data_script";

# Make sure that they have gone through the store correctly.  If there 
# has been no userid assigned by now, there has been some problem..perhaps 
# they jumped into the store from a search engine.

  if ($MYDATA{'userid'} eq "")
    {
    print "Content-type: text/html \n\n";
    print "<HTML><HEAD><TITLE>Smokin Joe's Warehouse</TITLE></HEAD><BODY>";
    print "<H2><CENTER>Sorry, you must start from the store enterance.";  
    print " Click <A HREF = \"http://www.intbc.com/smokin/\">here</A>";
    print "</CENTER></H2></BODY></HTML>";
    die;
    }

# Begin the HTML response

  print "Content-type: text/html \n\n";

# Set some internally relevant variables

  $referring_page = "$MYDATA{'referring_page'}";
  $userid = "$MYDATA{'userid'}";
  $page = "$MYDATA{'page'}";
  $back_page = "$MYDATA{'back_page'}";

# Check to see what the client is interested in seeing

  if ($MYDATA{'submit_type'} eq "View/Modify Cart")
    {
    &view_cart;
    }

  if ($MYDATA{'submit_type'} eq "Checkout Stand")
    {
    &check_out_stand;
    }

  if ($MYDATA{'submit_type'} eq "I Need Help")
    {
    &i_need_help;
    }

  if ($MYDATA{'submit_type'} eq "Go Back A Page")
    {
    &go_back_a_page;
    }

# If the script has gone this far, it means that the client is adding.  
# So now we add the items.  First let us get a list of the items which are 
# contained in valuelist which is a variable from the get_form_data scrits.

  open (TEMPFILE, ">$client_directory/$userid.temp");
  print TEMPFILE "$valuelist";
  close (TEMPFILE);

# Now we'll use that info to add items to the shopping cart

  open (TEMPFILE, "$client_directory/$userid.temp");

  while (<TEMPFILE>)
    {
    open (SHOPPINGCART, ">>$client_directory/$userid.cart");

# First check out the last item to be entered to get a line number

    $line = `tail -1 $client_directory/$userid.cart`;
    @grepfields = split (/:/, $line);
    $linenumber = "";

    if ($grepfields[4] eq "")
      {
      $linenumber = "1";
      }
    else
      {
      $linenumber = ($grepfields[4]+=1);
      }

    chop $valuelist;
    @lines = split (/\n/, $_);
    print SHOPPINGCART "$lines[0]:$linenumber\n";
    close (SHOPPINGCART);
    }
  close (TEMPFILE);

# Now return them to where they were

  open (PAGE, "$docs_directory/$MYDATA{'referring_page'}");

  while (<PAGE>)
    {
    print $_;
    }
  print "<INPUT TYPE = \"hidden\" NAME = \"referring_page\" VALUE = \"$MYDATA{'referring_page'}\">";
  print "<INPUT TYPE = \"hidden\" NAME = \"userid\" VALUE = \"$MYDATA{'userid'}\">";
  close (PAGE);


##############################################################################
#                                 Subroutines                                #
##############################################################################

  sub view_cart
    {
    print "<CENTER>";
    print "<FORM METHOD=\"POST\" ACTION=\"http://www.intbc.com/~ibc/cgi-bin/Smoke/build_shopping_cart.cgi\">";
    print "<INPUT TYPE = \"submit\" NAME = \"submit_type\" VALUE = \"View/Modify Cart\">";
    print "<INPUT TYPE = \"submit\" NAME = \"submit_type\" VALUE = \"Checkout Stand\">";
    print "<INPUT TYPE = \"submit\" NAME = \"submit_type\" VALUE = \"I Need Help\">";
    print "<INPUT TYPE = \"hidden\" NAME = \"referring_page\" VALUE = \"$MYDATA{'referring_page'}\">";
    print "<INPUT TYPE = \"hidden\" NAME = \"userid\" VALUE = \"$MYDATA{'userid'}\">";
    print "</CENTER></FORM>";
    print "<TABLE BORDER = \"1\" CELLPADDING = \"4\" CELLSPACING = \"4\">";
    print "<FORM ACTION = \"$process_cart_script\" METHOD = \"post\">";
    $grand_total=0;
    print "<TR ALIGN = \"center\"><TH>Delete<BR>Item</TH>";
    print "<TH>Change<BR>Quantity</TH><TH>Item ID</TH><TH>Description</TH>";
    print "<TH>Price</TH><TH>Quantity</TH><TH>Subtotal</TH></TH>";
    open (SHOPPINGCART, "$client_directory/$userid.cart");
    system ("rm $client_directory/$userid.temp");
    while (<SHOPPINGCART>)
      {
      @grepfields=split(/:/,$_);
      $itemid = $grepfields[0];
      $description = $grepfields[1];
      $price = $grepfields[2];
      $quantity = $grepfields[3];
      $linenumber = $grepfields[4];
      $total_price = $quantity*$price;
      $subprice = sprintf ("%.2f\n", $total_price);
      $grand_total=$grand_total+$total_price;
      $formatted_grand_total = sprintf ("%.2f\n", $grand_total);
      print "<TR><TD ALIGN = \"center\"><INPUT TYPE = \"radio\" NAME = \"delete\" VALUE = \"$linenumber\"></TD>";
      chop $linenumber;
      if ($linenumber eq "")
        {
        $linenumber = "1";
        }
      print "<TD ALIGN=\"center\"><INPUT TYPE = \"text\" NAME = \"$linenumber:$quantity\" SIZE = \"3\" MAXLENGTH = \"4\"></TD>";
      print "<TD>$itemid</TD><TD>$description</TD><TD>\$$price</TD>";
      print "<TD>$quantity</TD><TD>\$$subprice</TD></TR>";
      }
      close (SHOPPINGCART);
      system ("chmod 777 $client_directory/$userid.cart");
      print "</TABLE><P>";
      print "<P><CENTER><B>Current Item Total</B>: \$$formatted_grand_total<P>";
      print "<INPUT TYPE = \"hidden\" NAME = \"referring_page\" VALUE = \"$MYDATA{'referring_page'}\">";
      print "<INPUT TYPE = \"hidden\" NAME = \"userid\" VALUE = \"$MYDATA{'userid'}\">";
      print "<INPUT TYPE = \"submit\" NAME = \"submit_type\" VALUE = \"Delete Item\">";
      print "<INPUT TYPE = \"submit\" NAME = \"submit_type\" VALUE = \"Change Quantity\">";
      print "<INPUT TYPE = \"reset\" NAME = \"submit_type\"";
      print "VALUE = \"Reset This Form\">";
      print "</CENTER>";
      print "<P><HR><BR>";
      print "<P><A HREF=\"browse_warehouse.cgi?referring_page=$MYDATA{'page'}&userid=$MYDATA{'userid'}&page=index.html\">";
      print "<img align=middle hspace=6 src = \"$back_button\">Smokin Joes Home</A>";
      print "</FORM></BODY></HTML>";
      die;
      }

sub go_back_a_page

  {
  open (PAGE, "$docs_directory/$MYDATA{'referring_page'}");

  while (<PAGE>)
    {
    print $_;
    }
  close (PAGE);
  print "<P><A HREF=\"browse_warehouse.cgi?referring_page=$MYDATA{'page'}&userid=$MYDATA{'userid'}&page=index.html\">";
  print "<img align=middle hspace=6 src = \"$back_button\">Smokin Joes Home</A>";
  print "</CENTER>";

  }
sub i_need_help
  {
  open (PAGE, "$docs_directory/help.html");
  $searchstring = "userid";
  $replacestring = "userid=$userid";
  system ("sed s/$searchstring/$replacestring/g $docs_directory/help.html > $tempfile1");
  open (OUTPUT, "$tempfile1");
  while (<OUTPUT>)
    {
    print "$_";
    }
  system ("rm $tempfile1");
  print "<INPUT TYPE = \"hidden\" NAME = \"referring_page\" VALUE = \"$MYDATA{'referring_page'}\">";
  print "<INPUT TYPE = \"hidden\" NAME = \"userid\" VALUE = \"$MYDATA{'userid'}\">";
  print "</FORM></BODY></HTML>";
  die;
  }

sub check_out_stand
  {
  print "<HTML><HEAD><TITLE>$build_shopping_cart_title</TITLE>";
  print "</HEAD>\n";
  print "<BODY>\n";
  print "<CENTER>";
  print "<FORM METHOD=\"POST\" ACTION=\"http://www.intbc.com/~ibc/cgi-bin/Smoke/build_shopping_cart.cgi\">";
  print "<INPUT TYPE = \"submit\" NAME = \"submit_type\" VALUE = \"View/Modify Cart\">";
  print "<INPUT TYPE = \"submit\" NAME = \"submit_type\" VALUE = \"Checkout Stand\">";
  print "<INPUT TYPE = \"submit\" NAME = \"submit_type\" VALUE = \"I Need Help\">";
  print "<INPUT TYPE = \"hidden\" NAME = \"referring_page\" VALUE = \"$MYDATA{'referring_page'}\">";
  print "<INPUT TYPE = \"hidden\" NAME = \"userid\" VALUE = \"$MYDATA{'userid'}\">";
  print "</CENTER></FORM>";
  print "<CENTER><H2>Shopping Cart Contents</H2></CENTER>";
  print "<b><I>Note: Gift Wrapping adds \$10.00 per item to your total</I><b>";
  $shopping_cart = "$client_directory/$MYDATA{'userid'}.cart";
  print "<FORM METHOD=\"POST\" ACTION=\"$send_in_order_script_url\">";
  print "<TABLE BORDER = \"1\" CELLPADDING = \"4\" CELLSPACING = \"4\">";
  $grand_total=0;
  print "<TR ALIGN = \"center\"><TH>Gift<BR>Wrap?</TH><TH>ItemID</TH>";
  print "<TH>Description</TH><TH>Price</TH><TH>Quantity</TH>";
  print "<TH>Subtotal</TH></TR>";

  open (SHOPPINGCART, "$shopping_cart");
  while (<SHOPPINGCART>)
      {
      @grepfields=split(/:/,$_);
      $itemid = $grepfields[0];
      $description = $grepfields[1];
      $price = $grepfields[2];
      $quantity = $grepfields[3];
      $linenumber = $grepfields[4];
      $total_price = $quantity*$price;
      $subprice = sprintf ("%.2f\n", $total_price);
      $grand_total=$grand_total+$total_price;
      $formatted_grand_total = sprintf ("%.2f\n", $grand_total);
      print "<TR><TD><INPUT TYPE =\"radio\" NAME = \"$itemid\" VALUE = \"$quantity\"></TD>";
      print "<TD ALIGN = \"center\">";
      print "$itemid</TD><TD>$description</TD><TD>\$$price</TD>";
      print "<TD>$quantity</TD><TD>\$$subprice</TD></TR>";
      }
    close (SHOPPINGCART);

      print "<TR><TD colspan=5><B><B>Current Item Total</B>:</B></TD>";
      print "<TD>\$$formatted_grand_total</TD></TR>";
      print "<TR><TD colspan=2><B>Shipping and Handling:</B></TD>";
      print "<TD colspan=4>
             <SELECT NAME=shipping_method>
             <OPTION UPS_Ground>UPS Ground - \$5.00
             <OPTION UPS_3Day_48>UPS 3 Day (48 States) - \$7.00
             <OPTION UPS_3Day_AL_HI>UPS 3 Day (AL & HI) - \$9.00
             <OPTION UPS_2Day_48>UPS 2 Day (48 States) - \$9.00
             <OPTION UPS_2Day_AL_HI>UPS 2 Day (AL & HI) - \$15.00
             <OPTION UPS_NextDay_48>UPS Next Day (48 States) - \$19.00
             <OPTION UPS_NextDay_AL_HI>UPS Next Day (AL & HI) - \$27.00
             <OPTION UPS_Sat>UPS Saturday Delivery (48 States) - \$27.00
             </SELECT></TD></TR>";
       print "<TR><td><INPUT NAME=cod TYPE=checkbox></TD>";
       print "<TD colspan=5><B>C.O.D. Charge \$5.00:</B> Check for order to be shipped C.O.D. <i>C.O.D. orders for cash, cashiers check, certified funds or US Postal money order <b>only</b>.  Not available in Canada</i></TD></TR>";
       print "<tr><th align=left>Pay By</th>";
       print "<td colspan=5><INPUT TYPE=radio NAME=payment_method VALUE=Card>Credit Card ";
       print "<INPUT TYPE=radio NAME= payment_method VALUE=Check>Check ";
       print "<INPUT TYPE=radio NAME= payment_method VALUE=Cash_Check>Cashiers Check ";
       print "<INPUT TYPE=radio NAME= payment_method VALUE=Money_Order>Money Order ";
       print "<INPUT TYPE=radio NAME= payment_method VALUE=Cert_Funds>Certified Funds</td></tr>";
       print "</table><table><tr>";
       print " <td>Credit Card Number</td>";
       print "<td><INPUT NAME=card_number TYPE=text SIZE=20 MAXSIZE=20></td>"; 
       print "</tr><tr>";
       print "<td>Expiration Date (mm/dd)</td>";
       print "<td><INPUT NAME=card_expire TYPE=text SIZE=5 ></td>";
       print "</tr><tr>";
       print "<td>Name Appearing on Card</td>";
       print "<td><INPUT NAME=card_holder TYPE=text SIZE=20></td>";
       print "</tr><tr>";
       print "<th align=left>Comments</th>";
       print "<td colspan=3><TEXTAREA NAME=comments ROWS=3 COLS=50></TEXTAREA></td>";
       print "</tr>";
       print "</table><TABLE><tr>";
       print "<th align=left>Billing Address</th>";
       print "<td colspan=3><TEXTAREA NAME=billing_address ROWS=4 COLS=50></TEXTAREA></td>";
       print "</tr><tr>";
       print "<td><b>Shipping Address</b><br> If different<br>from Billing<br>Address</th>";
       print "<td colspan=3><TEXTAREA NAME=shipping_address ROWS=4 COLS=50></TEXTAREA></td>";
       print "<br></tr></table>";
       print "<table border=4 width=100%></table>";
       print "<table border=4 width=100%><tr></tr></table>";
    print "<CENTER>";
    print "<INPUT TYPE = \"submit\" NAME = \"submit_type\" VALUE = \"View/Modify Cart\">";
    print "<INPUT TYPE = \"submit\" NAME = \"submit_type\" VALUE = \"Checkout Stand\">";
    print "<INPUT TYPE = \"submit\" NAME = \"submit_type\" VALUE = \"I Need Help\">";
    print "<INPUT TYPE = \"hidden\" NAME = \"subtotal\" VALUE = \"$formatted_grand_total\">";
    print "<INPUT TYPE = \"hidden\" NAME = \"userid\" VALUE = \"$MYDATA{'userid'}\">";
    print "<CENTER><P><INPUT TYPE = \"submit\" VALUE = \"Send in your order\">";
    print "</CENTER></FORM><P><HR>";
    print "<P><A HREF=\"browse_warehouse.cgi?referring_page=$MYDATA{'page'}&userid=$MYDATA{'userid'}&page=index.html\"><img align=middle hspace=6 src= \"$back_button\">Smokin' Joes Home</A>";
    print "</BODY></HTML>";
die;

  }
